Something that has always bothered me about pip in Python is that you would get errors about inconsistent packages. Things still seemed to work surprisingly often, but it meant that the order you installed packages could lead to very different results (and one ordering may cause your test to fail, even if that doesn't succeed).

Now there is a new resolver in Pip 20.3 for pip that checks the dependencies and tries to find versions that meet all constraints. This is a huge step forward for Python, and makes it easier to adopt.